VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTruss"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'
'    Copyright (C) 2008  Colin Caprani - www.colincaprani.com
'
'    This program is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    This program is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with this program.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit

Private m_nj As Integer
Private m_nm As Integer
Private m_jData() As Single
Private m_mData() As Single
Private m_openfile As String
Private m_max As Integer
Private m_pl As Single
Private m_nodeLoad As Single
Const m_noConstants As Integer = 2
Public Enum trussTypeConstants
    Pratt = 1
    Warren = 2
End Enum
Public Enum loadTypeConstants
    udl = 1
    PL = 2
End Enum
'local variable(s) to hold property value(s)
Private m_L As Single
Private m_np As Integer
Private m_h As Single
Private m_config As trussTypeConstants
Private m_loadType As loadTypeConstants
Private m_webE As Single
Private m_webA As Single
Private m_topE As Single
Private m_topA As Single
Private m_btmE As Single
Private m_btmA As Single
Private m_loadValue As Single


Public Sub saveFile()
'MsgBox "Hello!! " & m_L & " was the input L" & vbCrLf & " Type: " & m_config
Call generateData
Call FileSave
End Sub

Private Sub FileSave()
Dim FNum As Integer, sFile As String

On Error GoTo FileError
    FNum = FreeFile
    
    Open m_openfile For Binary As #FNum
    PutInfo (FNum)
    Close #FNum
    
    Exit Sub

FileError:
        MsgBox "Error while saving file " & m_openfile & vbCrLf & Err.Description, vbCritical, "TrussGenerator"
End Sub

Private Sub PutInfo(FNum As Integer)
    
    Put #FNum, , m_max
    Put #FNum, , m_nj
    Put #FNum, , m_nm
    Put #FNum, , m_jData()
    Put #FNum, , m_mData()
    
End Sub

Private Sub generateData()
Select Case m_config
    Case 1 'Pratt
        Call generatePratt
    Case Else
        MsgBox "No such generator yet available", vbInformation, "TrussGenerator"
End Select
End Sub

Private Sub generatePratt()
Dim i As Integer, p As Integer 'p is a member counter

m_pl = m_L / m_np

m_nj = 2 * m_np + 2
m_nm = 4 * m_np + 1

If Not m_np = Round(m_np / 2, 0) * 2 Then
    'not an even number of panels
    m_nm = m_nm + 1
End If

ReDim m_jData(m_nj, 5)
ReDim m_mData(m_nm, 8)

'///////////////// JOINT DATA GENERATION ///////////////
m_jData(1, 5) = 1 'pinned
m_jData(m_np + 1, 5) = 2 'roller

'node loading
Select Case m_loadType
    Case udl
        m_nodeLoad = m_pl * m_loadValue
    Case Else
        m_nodeLoad = m_loadValue
End Select

For i = 1 To m_np + 1
    m_jData(i, 1) = (i - 1) * m_pl
    m_jData(i, 2) = 0
Next i
For i = m_np + 2 To m_nj
    m_jData(i, 1) = m_jData(i - (m_np + 1), 1)
    m_jData(i, 2) = m_h
    m_jData(i, 4) = -m_nodeLoad
Next i

m_jData(m_np + 2, 4) = -m_nodeLoad / 2
m_jData(m_nj, 4) = -m_nodeLoad / 2

'///////////////// MEMBER DATA GENERATION ///////////////
'lower chord line
For i = 1 To m_np
    m_mData(i, 1) = i
    m_mData(i, 2) = i + 1
    m_mData(i, 3) = m_btmE
    m_mData(i, 4) = m_btmA
Next i
p = m_np
'upper chord line
For i = m_np + 3 To 2 * m_np + 2
    p = p + 1
    m_mData(p, 1) = i - 1
    m_mData(p, 2) = i
    m_mData(p, 3) = m_topE
    m_mData(p, 4) = m_topA
Next i

'web material data
For i = p + 1 To m_nm
    m_mData(i, 3) = m_webE
    m_mData(i, 4) = m_webA
Next i

'verticals
For i = 1 To m_np + 1
    p = p + 1
    m_mData(p, 1) = i
    m_mData(p, 2) = i + m_np + 1
Next i
'left diagonals
For i = 1 To CInt(m_np / 2)
    p = p + 1
    m_mData(p, 1) = i + m_np + 1
    m_mData(p, 2) = i + 1
Next i
'right diagonals
For i = CInt(m_np / 2) To m_np
    p = p + 1
    m_mData(p, 1) = i + m_np + 2
    m_mData(p, 2) = i
Next i

m_max = m_nj
If m_nm > m_nj Then m_max = m_nm
End Sub

Public Property Get noConstants() As Integer
    noConstants = m_noConstants
End Property

Public Property Let config(ByVal vData As trussTypeConstants)
    m_config = vData
End Property

Public Property Get config() As trussTypeConstants
    'Set config = m_config
End Property

Public Property Let h(ByVal vData As Single)
    m_h = vData
End Property

Public Property Get h() As Single
    h = m_h
End Property

Public Property Let np(ByVal vData As Integer)
    m_np = vData
End Property

Public Property Get np() As Integer
    np = m_np
End Property

Public Property Let L(ByVal vData As Single)
    m_L = vData
End Property

Public Property Get L() As Single
    L = m_L
End Property

Public Property Let loadValue(ByVal vData As Single)
    m_loadValue = vData
End Property

Public Property Get loadValue() As Single
    loadValue = m_loadValue
End Property

Public Property Let btmA(ByVal vData As Single)
    m_btmA = vData
End Property

Public Property Get btmA() As Single
    btmA = m_btmA
End Property

Public Property Let btmE(ByVal vData As Single)
    m_btmE = vData
End Property

Public Property Get btmE() As Single
    btmE = m_btmE
End Property

Public Property Let topA(ByVal vData As Single)
    m_topA = vData
End Property

Public Property Get topA() As Single
    topA = m_topA
End Property

Public Property Let topE(ByVal vData As Single)
    m_topE = vData
End Property

Public Property Get topE() As Single
    topE = m_topE
End Property

Public Property Let webA(ByVal vData As Single)
    m_webA = vData
End Property

Public Property Get webA() As Single
    webA = m_webA
End Property

Public Property Let webE(ByVal vData As Single)
    m_webE = vData
End Property

Public Property Get webE() As Single
    webE = m_webE
End Property

Public Property Let loadType(ByVal vData As loadTypeConstants)
    m_loadType = vData
End Property

Public Property Get loadType() As loadTypeConstants
    'Set loadType = m_loadType
End Property

Public Property Let openfile(ByVal vData As String)
    m_openfile = vData
End Property

Public Property Get openfile() As String
    openfile = m_openfile
End Property



